#################################################################################################
#parallel.py
#Author: Swetha Varadarajan
#Last Update by Swetha Varadarajan: Oct 20, 2018
#Usage: python parallel.py
#################################################################################################
#More details:
#Polyhedral Optimizations of RNA-RNA Interaction Computations
#MS Thesis: Swetha Vardarajan, Defended: Oct 26,2017
#Advisor: Sanjay Rajopadhye
#################################################################################################
#For more details, contact: varadarajan.swetha@gmail.com
#################################################################################################

import numpy as np
import matplotlib.pyplot as plt
import math
from textwrap import wrap
 
f, axarr = plt.subplots(2,2, sharex=True)

# data to plot
data = np.loadtxt('ospsq-base-par.txt')

axarr[0,0].plot(data[:,0],data[:,1],color='green', linestyle='solid', marker='o',markerfacecolor='green', markersize=7,label='16,750')
axarr[0,0].plot(data[:,0],data[:,2],color='blue', linestyle='solid', marker='o',markerfacecolor='blue', markersize=7,label='20,750')
axarr[0,0].plot(data[:,0],data[:,3],color='red', linestyle='solid', marker='o',markerfacecolor='red', markersize=7,label='22,750')
axarr[0,0].plot(data[:,0],data[:,4],color='yellow', linestyle='solid', marker='o',markerfacecolor='yellow', markersize=7,label='25,750')
axarr[0,0].plot(data[:,0],data[:,5],color='magenta', linestyle='solid', marker='o',markerfacecolor='magenta', markersize=7,label='30,750')
axarr[0,0].plot(data[:,0],data[:,6],color='green', linestyle='solid', marker='^',markerfacecolor='green', markersize=7,label='16,1000')
axarr[0,0].plot(data[:,0],data[:,7],color='blue', linestyle='solid', marker='^',markerfacecolor='blue', markersize=7,label='20,1000')
axarr[0,0].plot(data[:,0],data[:,8],color='red', linestyle='solid', marker='^',markerfacecolor='red', markersize=7,label='22,1000')
axarr[0,0].plot(data[:,0],data[:,9],color='yellow', linestyle='solid', marker='^',markerfacecolor='yellow', markersize=7,label='25,1000')
axarr[0,0].plot(data[:,0],data[:,10],color='magenta', linestyle='solid', marker='^',markerfacecolor='magenta', markersize=7,label='30,1000')
axarr[0,0].plot(data[:,0],data[:,11],color='green', linestyle='solid', marker='D',markerfacecolor='green', markersize=7,label='16,1500')
axarr[0,0].plot(data[:,0],data[:,12],color='blue', linestyle='solid', marker='D',markerfacecolor='blue', markersize=7,label='20,1500')
axarr[0,0].plot(data[:,0],data[:,13],color='red', linestyle='solid', marker='D',markerfacecolor='red', markersize=7,label='22,1500')
axarr[0,0].plot(data[:,0],data[:,14],color='yellow', linestyle='solid', marker='D',markerfacecolor='yellow', markersize=7,label='25,1500')
axarr[0,0].plot(data[:,0],data[:,15],color='magenta', linestyle='solid', marker='D',markerfacecolor='magenta', markersize=7,label='30,1500')
axarr[0,0].plot(data[:,0],data[:,16],color='green', linestyle='solid', marker='*',markerfacecolor='green', markersize=12,label='16,2000')
axarr[0,0].plot(data[:,0],data[:,17],color='blue', linestyle='solid', marker='*',markerfacecolor='blue', markersize=12,label='20,2000')
axarr[0,0].plot(data[:,0],data[:,18],color='red', linestyle='solid', marker='*',markerfacecolor='red', markersize=12,label='22,2000')
axarr[0,0].plot(data[:,0],data[:,19],color='yellow', linestyle='solid', marker='*',markerfacecolor='yellow', markersize=12,label='25,2000')
axarr[0,0].plot(data[:,0],data[:,20],color='magenta', linestyle='solid', marker='*',markerfacecolor='magenta', markersize=12,label='30,2000')
axarr[0,0].plot(data[:,0],data[:,21],color='green', linestyle='solid', marker='p',markerfacecolor='green', markersize=12,label='16,2500')
axarr[0,0].plot(data[:,0],data[:,22],color='blue', linestyle='solid', marker='p',markerfacecolor='blue', markersize=12,label='20,2500')
axarr[0,0].plot(data[:,0],data[:,23],color='red', linestyle='solid', marker='p',markerfacecolor='red', markersize=12,label='22,2500')
axarr[0,0].plot(data[:,0],data[:,24],color='yellow', linestyle='solid', marker='p',markerfacecolor='yellow', markersize=12,label='25,2500')
axarr[0,0].plot(data[:,0],data[:,25],color='magenta', linestyle='solid', marker='p',markerfacecolor='magenta', markersize=12,label='30,2500')

data = np.loadtxt('ospsq-best-col-coarse.txt')

axarr[0,1].plot(data[:,0],data[:,1],color='green', linestyle='solid', marker='o',markerfacecolor='green', markersize=7)
axarr[0,1].plot(data[:,0],data[:,2],color='blue', linestyle='solid', marker='o',markerfacecolor='blue', markersize=7)
axarr[0,1].plot(data[:,0],data[:,3],color='red', linestyle='solid', marker='o',markerfacecolor='red', markersize=7)
axarr[0,1].plot(data[:,0],data[:,4],color='yellow', linestyle='solid', marker='o',markerfacecolor='yellow', markersize=7)
axarr[0,1].plot(data[:,0],data[:,5],color='magenta', linestyle='solid', marker='o',markerfacecolor='magenta', markersize=7)
axarr[0,1].plot(data[:,0],data[:,6],color='green', linestyle='solid', marker='^',markerfacecolor='green', markersize=7)
axarr[0,1].plot(data[:,0],data[:,7],color='blue', linestyle='solid', marker='^',markerfacecolor='blue', markersize=7)
axarr[0,1].plot(data[:,0],data[:,8],color='red', linestyle='solid', marker='^',markerfacecolor='red', markersize=7)
axarr[0,1].plot(data[:,0],data[:,9],color='yellow', linestyle='solid', marker='^',markerfacecolor='yellow', markersize=7)
axarr[0,1].plot(data[:,0],data[:,10],color='magenta', linestyle='solid', marker='^',markerfacecolor='magenta', markersize=7)
axarr[0,1].plot(data[:,0],data[:,11],color='green', linestyle='solid', marker='D',markerfacecolor='green', markersize=7)
axarr[0,1].plot(data[:,0],data[:,12],color='blue', linestyle='solid', marker='D',markerfacecolor='blue', markersize=7)
axarr[0,1].plot(data[:,0],data[:,13],color='red', linestyle='solid', marker='D',markerfacecolor='red', markersize=7)
axarr[0,1].plot(data[:,0],data[:,14],color='yellow', linestyle='solid', marker='D',markerfacecolor='yellow', markersize=7)
axarr[0,1].plot(data[:,0],data[:,15],color='magenta', linestyle='solid', marker='D',markerfacecolor='magenta', markersize=7)
axarr[0,1].plot(data[:,0],data[:,16],color='green', linestyle='solid', marker='*',markerfacecolor='green', markersize=12)
axarr[0,1].plot(data[:,0],data[:,17],color='blue', linestyle='solid', marker='*',markerfacecolor='blue', markersize=12)
axarr[0,1].plot(data[:,0],data[:,18],color='red', linestyle='solid', marker='*',markerfacecolor='red', markersize=12)
axarr[0,1].plot(data[:,0],data[:,19],color='yellow', linestyle='solid', marker='*',markerfacecolor='yellow', markersize=12)
axarr[0,1].plot(data[:,0],data[:,20],color='magenta', linestyle='solid', marker='*',markerfacecolor='magenta', markersize=12)
axarr[0,1].plot(data[:,0],data[:,21],color='green', linestyle='solid', marker='p',markerfacecolor='green', markersize=12)
axarr[0,1].plot(data[:,0],data[:,22],color='blue', linestyle='solid', marker='p',markerfacecolor='blue', markersize=12)
axarr[0,1].plot(data[:,0],data[:,23],color='red', linestyle='solid', marker='p',markerfacecolor='red', markersize=12)
axarr[0,1].plot(data[:,0],data[:,24],color='yellow', linestyle='solid', marker='p',markerfacecolor='yellow', markersize=12)
axarr[0,1].plot(data[:,0],data[:,25],color='magenta', linestyle='solid', marker='p',markerfacecolor='magenta', markersize=12)

data = np.loadtxt('ospsq-best-col-fine.txt')

axarr[1,0].plot(data[:,0],data[:,1],color='green', linestyle='solid', marker='o',markerfacecolor='green', markersize=7)
axarr[1,0].plot(data[:,0],data[:,2],color='blue', linestyle='solid', marker='o',markerfacecolor='blue', markersize=7)
axarr[1,0].plot(data[:,0],data[:,3],color='red', linestyle='solid', marker='o',markerfacecolor='red', markersize=7)
axarr[1,0].plot(data[:,0],data[:,4],color='yellow', linestyle='solid', marker='o',markerfacecolor='yellow', markersize=7)
axarr[1,0].plot(data[:,0],data[:,5],color='magenta', linestyle='solid', marker='o',markerfacecolor='magenta', markersize=7)
axarr[1,0].plot(data[:,0],data[:,6],color='green', linestyle='solid', marker='^',markerfacecolor='green', markersize=7)
axarr[1,0].plot(data[:,0],data[:,7],color='blue', linestyle='solid', marker='^',markerfacecolor='blue', markersize=7)
axarr[1,0].plot(data[:,0],data[:,8],color='red', linestyle='solid', marker='^',markerfacecolor='red', markersize=7)
axarr[1,0].plot(data[:,0],data[:,9],color='yellow', linestyle='solid', marker='^',markerfacecolor='yellow', markersize=7)
axarr[1,0].plot(data[:,0],data[:,10],color='magenta', linestyle='solid', marker='^',markerfacecolor='magenta', markersize=7)
axarr[1,0].plot(data[:,0],data[:,11],color='green', linestyle='solid', marker='D',markerfacecolor='green', markersize=7)
axarr[1,0].plot(data[:,0],data[:,12],color='blue', linestyle='solid', marker='D',markerfacecolor='blue', markersize=7)
axarr[1,0].plot(data[:,0],data[:,13],color='red', linestyle='solid', marker='D',markerfacecolor='red', markersize=7)
axarr[1,0].plot(data[:,0],data[:,14],color='yellow', linestyle='solid', marker='D',markerfacecolor='yellow', markersize=7)
axarr[1,0].plot(data[:,0],data[:,15],color='magenta', linestyle='solid', marker='D',markerfacecolor='magenta', markersize=7)
axarr[1,0].plot(data[:,0],data[:,16],color='green', linestyle='solid', marker='*',markerfacecolor='green', markersize=12)
axarr[1,0].plot(data[:,0],data[:,17],color='blue', linestyle='solid', marker='*',markerfacecolor='blue', markersize=12)
axarr[1,0].plot(data[:,0],data[:,18],color='red', linestyle='solid', marker='*',markerfacecolor='red', markersize=12)
axarr[1,0].plot(data[:,0],data[:,19],color='yellow', linestyle='solid', marker='*',markerfacecolor='yellow', markersize=12)
axarr[1,0].plot(data[:,0],data[:,20],color='magenta', linestyle='solid', marker='*',markerfacecolor='magenta', markersize=12)
axarr[1,0].plot(data[:,0],data[:,21],color='green', linestyle='solid', marker='p',markerfacecolor='green', markersize=12)
axarr[1,0].plot(data[:,0],data[:,22],color='blue', linestyle='solid', marker='p',markerfacecolor='blue', markersize=12)
axarr[1,0].plot(data[:,0],data[:,23],color='red', linestyle='solid', marker='p',markerfacecolor='red', markersize=12)
axarr[1,0].plot(data[:,0],data[:,24],color='yellow', linestyle='solid', marker='p',markerfacecolor='yellow', markersize=12)
axarr[1,0].plot(data[:,0],data[:,25],color='magenta', linestyle='solid', marker='p',markerfacecolor='magenta', markersize=12)

data = np.loadtxt('ospsq-best-row-par.txt')

axarr[1,1].plot(data[:,0],data[:,1],color='green', linestyle='solid', marker='o',markerfacecolor='green', markersize=7)
axarr[1,1].plot(data[:,0],data[:,2],color='blue', linestyle='solid', marker='o',markerfacecolor='blue', markersize=7)
axarr[1,1].plot(data[:,0],data[:,3],color='red', linestyle='solid', marker='o',markerfacecolor='red', markersize=7)
axarr[1,1].plot(data[:,0],data[:,4],color='yellow', linestyle='solid', marker='o',markerfacecolor='yellow', markersize=7)
axarr[1,1].plot(data[:,0],data[:,5],color='magenta', linestyle='solid', marker='o',markerfacecolor='magenta', markersize=7)
axarr[1,1].plot(data[:,0],data[:,6],color='green', linestyle='solid', marker='^',markerfacecolor='green', markersize=7)
axarr[1,1].plot(data[:,0],data[:,7],color='blue', linestyle='solid', marker='^',markerfacecolor='blue', markersize=7)
axarr[1,1].plot(data[:,0],data[:,8],color='red', linestyle='solid', marker='^',markerfacecolor='red', markersize=7)
axarr[1,1].plot(data[:,0],data[:,9],color='yellow', linestyle='solid', marker='^',markerfacecolor='yellow', markersize=7)
axarr[1,1].plot(data[:,0],data[:,10],color='magenta', linestyle='solid', marker='^',markerfacecolor='magenta', markersize=7)
axarr[1,1].plot(data[:,0],data[:,11],color='green', linestyle='solid', marker='D',markerfacecolor='green', markersize=7)
axarr[1,1].plot(data[:,0],data[:,12],color='blue', linestyle='solid', marker='D',markerfacecolor='blue', markersize=7)
axarr[1,1].plot(data[:,0],data[:,13],color='red', linestyle='solid', marker='D',markerfacecolor='red', markersize=7)
axarr[1,1].plot(data[:,0],data[:,14],color='yellow', linestyle='solid', marker='D',markerfacecolor='yellow', markersize=7)
axarr[1,1].plot(data[:,0],data[:,15],color='magenta', linestyle='solid', marker='D',markerfacecolor='magenta', markersize=7)
axarr[1,1].plot(data[:,0],data[:,16],color='green', linestyle='solid', marker='*',markerfacecolor='green', markersize=12)
axarr[1,1].plot(data[:,0],data[:,17],color='blue', linestyle='solid', marker='*',markerfacecolor='blue', markersize=12)
axarr[1,1].plot(data[:,0],data[:,18],color='red', linestyle='solid', marker='*',markerfacecolor='red', markersize=12)
axarr[1,1].plot(data[:,0],data[:,19],color='yellow', linestyle='solid', marker='*',markerfacecolor='yellow', markersize=12)
axarr[1,1].plot(data[:,0],data[:,20],color='magenta', linestyle='solid', marker='*',markerfacecolor='magenta', markersize=12)
axarr[1,1].plot(data[:,0],data[:,21],color='green', linestyle='solid', marker='p',markerfacecolor='green', markersize=12)
axarr[1,1].plot(data[:,0],data[:,22],color='blue', linestyle='solid', marker='p',markerfacecolor='blue', markersize=12)
axarr[1,1].plot(data[:,0],data[:,23],color='red', linestyle='solid', marker='p',markerfacecolor='red', markersize=12)
axarr[1,1].plot(data[:,0],data[:,24],color='yellow', linestyle='solid', marker='p',markerfacecolor='yellow', markersize=12)
axarr[1,1].plot(data[:,0],data[:,25],color='magenta', linestyle='solid', marker='p',markerfacecolor='magenta', markersize=12)

axarr[1,1].set_xlabel('Number of threads')
axarr[1,0].set_xlabel('Number of threads')

axarr[1,0].set_ylabel('GFLOPS')
axarr[1,1].set_ylabel('GFLOPS')
axarr[0,1].set_ylabel('GFLOPS')
axarr[0,0].set_ylabel('GFLOPS')

axarr[0,0].set_title('(a) base-coarse')
axarr[1,1].set_title('(d) vec+loc-row-fine')
axarr[0,1].set_title('(b) vec+loc-diag-coarse')
axarr[1,0].set_title('(c) vec+loc-diag-fine')

f.subplots_adjust(wspace=.5)

lgd = axarr[0,0].legend(loc='upper center', ncol=5, mode="expand", borderaxespad=0.,bbox_to_anchor=(-0.4, 1.6, 3, 0.4), title='Format: N,M')
f.savefig('par', bbox_extra_artists=(lgd,), bbox_inches='tight')

