// This file is generated from test alphabets program by code generator in alphaz
// To compile this code, use -lm option for math library.

// Includes
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>
#include <string.h>
#include <limits.h>
#include <float.h>
#include <omp.h>
#include <immintrin.h>
#include <malloc.h>


// Common Macros
#define max(x, y)   ((x)>(y) ? (x) : (y))
#define MAX(x, y)	((x)>(y) ? (x) : (y))
#define min(x, y)   ((x)>(y) ? (y) : (x))
#define MIN(x, y)	((x)>(y) ? (y) : (x))
#define CEILD(n,d)  (int)ceil(((double)(n))/((double)(d)))
#define ceild(n,d)  (int)ceil(((double)(n))/((double)(d)))
#define FLOORD(n,d) (int)floor(((double)(n))/((double)(d)))
#define floord(n,d) (int)floor(((double)(n))/((double)(d)))
#define CDIV(x,y)    CEILD((x),(y))
#define div(x,y)    CDIV((x),(y))
#define FDIV(x,y)    FLOORD((x),(y))
#define LB_SHIFT(b,s)  ((int)ceild(b,s) * s)
#define MOD(i,j)   ((i)%(j))
#define mallocCheck(v,s,d) if ((v) == NULL) { printf("Failed to allocate memory for %s : size=%lu\n", "sizeof(d)*(s)", sizeof(d)*(s)); exit(-1); }
// Reduction Operators
#define RADD(x,y)    ((x)+=(y))
#define RMUL(x,y)    ((x)*=(y))
#define RMAX(x,y)    ((x)=MAX((x),(y)))
#define RMIN(x,y)    ((x)=MIN((x),(y)))

// Common functions for min and max
//functions for integer max
inline int __max_int(int x, int y){
	return ((x)>(y) ? (x) : (y));
}

inline short __max_short(short x, short y){
	return ((x)>(y) ? (x) : (y));
}

inline long __max_long(long x, long y){
	return ((x)>(y) ? (x) : (y));
}

inline unsigned int __max_unsigned_int(unsigned int x, unsigned int y){
	return ((x)>(y) ? (x) : (y));
}

inline unsigned short __max_unsigned_short(unsigned short x, unsigned short y){
	return ((x)>(y) ? (x) : (y));
}

//function for float max
inline float __max_float(float x, float y){
	return ((x)>(y) ? (x) : (y));
}

//function for double max
inline double __max_double(double x, double y){
	return ((x)>(y) ? (x) : (y));
}

//function for integer min
inline int __min_int(int x, int y){
	return ((x)>(y) ? (y) : (x));
}

inline short __min_short(short x, short y){
	return ((x)>(y) ? (y) : (x));
}

inline long __min_long(long x, long y){
	return ((x)>(y) ? (y) : (x));
}

inline unsigned int __min_unsigned_int(unsigned int x, unsigned int y){
	return ((x)>(y) ? (y) : (x));
}

inline unsigned short __min_unsigned_short(unsigned short x, unsigned short y){
	return ((x)>(y) ? (y) : (x));
}

inline unsigned long __min_unsigned_long(unsigned long x, unsigned long y){
	return ((x)>(y) ? (y) : (x));
}

inline float __min_float(float x, float y){
	return ((x)>(y) ? (y) : (x));
}

inline double __min_double(double x, double y){
	return ((x)>(y) ? (y) : (x));
}





//Memory Macros
#define P1(i,j) P1[(i) * (N) + j]
#define P2(i,j) P2[(i) * (M) + j]
#define Q(i1,j1,i2,j2) Q[(i1) * ((N) * (max(M-1,M-2) + 1) * (M)) + (j1) * ((max(M-1,M-2) + 1) * (M)) + (i2) * (M) + j2]

void osp_sq(long N, long M, double* P1, double* P2, double* Q){
	///Parameter checking
	if (!((N >= 2 && M >= 2))) {
		printf("The value of parameters are not valid.\n");
		exit(-1);
	}
	//Memory Allocation
	
	#define S0(i1,j1,i2,j2,i4,i5) Q(j1,i1+j1,j2,i4) = P2(j2,i4)
	#define S1(i1,j1,i2,j2,i4,i5) Q(j1,i1+j1,j2,i4) = P1(j1,i1+j1)
	#define S2(i1,j1,i2,j2,i4,i5) Q(j1,i1+j1,j2,i4) = Q(j1,i1+j1,j2,i4)
	#define S3(i1,j1,i2,j2,d,e) Q(j1,i1+j1,j2,j2+e) = (Q(j1,i1+j1,j2,j2+e))+((Q(j1,i2,j2,d))*(Q(i2+1,i1+j1,d+1,j2+e)))
	#define S4(i1,j1,i2,j2,d,e) Q(j1,i1+j1,j2,j2+e) = (Q(j1,i1+j1,j2,j2+e))+((Q(j1,i2,j2,d))*(Q(i2+1,i1+j1,d+1,j2+e)))
	#define S5(i1,j1,i2,j2,d,e) Q(j1,i1+j1,j2,j2+e) = (Q(j1,i2,j2,d))*(Q(i2+1,i1+j1,d+1,j2+e))
	#define S6(i1,j1,i2,j2,d,e) Q(j1,i1+j1,j2,j2+e) = (Q(j1,i1+j1,j2,j2+e))+((Q(j1,i2,j2,d))*(Q(i2+1,i1+j1,d+1,j2+e)))
	{
		//Domain
		//{i1,j1,i2,j2,i4,i5|j2+i5==i4 && i2==j1 && i1==0 && N>=2 && M>=2 && j2>=0 && M>=i4+1 && i4>=j2 && N>=j1+1 && j1>=0}
		//{i1,j1,i2,j2,i4,i5|i5==0 && i4==j2 && i2==i1+j1 && i1>=1 && N>=2 && M>=2 && j1>=0 && N>=i1+j1+1 && M>=j2+1 && j2>=0}
		//{i1,j1,i2,j2,i4,i5|j2+i5==i4 && i2==i1+j1 && i4>=j2+1 && i1>=1 && N>=2 && M>=2 && M>=i4+1 && j2>=0 && j1>=0 && N>=i1+j1+1}
		//{i1,j1,i2,j2,d,e|d>=j2+1 && i2>=j1+1 && N>=2 && M>=2 && d>=-1 && j2+e>=d+1 && j1>=0 && N>=i1+j1+1 && j2>=0 && M>=j2+e+1 && M>=d+1 && i1+j1>=i2+1 && i2>=-1 && N>=i2+1}
		//{i1,j1,i2,j2,d,e|d==j2 && i2>=j1+1 && N>=2 && M>=2 && e>=1 && j2>=0 && j1>=0 && N>=i1+j1+1 && N>=i2+1 && M>=j2+e+1 && M>=j2+1 && i1+j1>=i2+1 && i2>=-1}
		//{i1,j1,i2,j2,d,e|d==j2 && i2==j1 && N>=2 && M>=2 && N>=j1+1 && j2>=0 && M>=j2+1 && N>=i1+j1+1 && j1>=0 && i1>=1 && e>=1 && M>=j2+e+1}
		//{i1,j1,i2,j2,d,e|i2==j1 && d>=j2+1 && N>=2 && M>=2 && N>=j1+1 && j2+e>=d+1 && j1>=0 && N>=i1+j1+1 && j2>=0 && M>=j2+e+1 && d>=-1 && i1>=1 && M>=d+1}
		int c1,c2,c3,c4,c5,c6;
		#pragma omp parallel for private(c4,c5) schedule(dynamic)
		for(c2=0;c2 <= N-1;c2+=1)
		 {
		 	for(c4=0;c4 <= M-1;c4+=1)
		 	 {
		 	 	for(c5=c4;c5 <= M-1;c5+=1)
		 	 	 {
		 	 	 	S0((0),(c2),(c2),(c4),(c5),(-c4+c5));
		 	 	 }
		 	 }
		 }
		if ((M >= 3)) {
			{
				#pragma omp parallel for private(c4,c5,c6) schedule(dynamic)
				for(c2=0;c2 <= N-2;c2+=1)
				 {
				 	for(c4=0;c4 <= M-3;c4+=1)
				 	 {
				 	 	for(c6=1;c6 <= -c4+M-1;c6+=1)
				 	 	 {
				 	 	 	S5((1),(c2),(c2),(c4),(c4),(c6));
				 	 	 }
				 	 	for(c5=c4+1;c5 <= M-2;c5+=1)
				 	 	 {
									#pragma ivdep
                                                			#pragma vector always
                                                			#pragma simd
				 	 	 	for(c6=-c4+c5+1;c6 <= -c4+M-1;c6+=1)
				 	 	 	 {
				 	 	 	 	S6((1),(c2),(c2),(c4),(c5),(c6));
				 	 	 	 }
				 	 	 }
				 	 }
				 	S5((1),(c2),(c2),(M-2),(M-2),(1));
				 	for(c4=0;c4 <= M-2;c4+=1)
				 	 {
				 	 	S1((1),(c2),(c2+1),(c4),(c4),(0));
				 	 	for(c5=c4+1;c5 <= M-1;c5+=1)
				 	 	 {
				 	 	 	S2((1),(c2),(c2+1),(c4),(c5),(-c4+c5));
				 	 	 }
				 	 }
				 	S1((1),(c2),(c2+1),(M-1),(M-1),(0));
				 }
			}
		}
		if ((M == 2)) {
			{
				#pragma omp parallel for schedule(dynamic)
				for(c2=0;c2 <= N-2;c2+=1)
				 {
				 	S5((1),(c2),(c2),(0),(0),(1));
				 	S1((1),(c2),(c2+1),(0),(0),(0));
				 	S2((1),(c2),(c2+1),(0),(1),(1));
				 	S1((1),(c2),(c2+1),(1),(1),(0));
				 }
			}
		}
		if ((M >= 3)) {
			{
				for(c1=2;c1 <= N-1;c1+=1)
				 { 
				 	#pragma omp parallel for private(c3,c4,c5,c6) schedule(dynamic)
				 	for(c2=0;c2 <= -c1+N-1;c2+=1)
				 	 {
				 	 	for(c4=0;c4 <= M-3;c4+=1)
				 	 	 {
				 	 	 	for(c6=1;c6 <= -c4+M-1;c6+=1)
				 	 	 	 {
				 	 	 	 	S5((c1),(c2),(c2),(c4),(c4),(c6));
				 	 	 	 }
				 	 	 	for(c5=c4+1;c5 <= M-2;c5+=1)
				 	 	 	 {
									#pragma ivdep
                                                			#pragma vector always
                                                			#pragma simd
				 	 	 	 	for(c6=-c4+c5+1;c6 <= -c4+M-1;c6+=1)
				 	 	 	 	 {
				 	 	 	 	 	S6((c1),(c2),(c2),(c4),(c5),(c6));
				 	 	 	 	 }
				 	 	 	 }
				 	 	 }
				 	 	S5((c1),(c2),(c2),(M-2),(M-2),(1));
				 	 	for(c3=c2+1;c3 <= c1+c2-1;c3+=1)
				 	 	 {
				 	 	 	for(c4=0;c4 <= M-3;c4+=1)
				 	 	 	 {
									#pragma ivdep
                                                			#pragma vector always
                                                			#pragma simd
				 	 	 	 	for(c6=1;c6 <= -c4+M-1;c6+=1)
				 	 	 	 	 {
				 	 	 	 	 	S4((c1),(c2),(c3),(c4),(c4),(c6));
				 	 	 	 	 }
				 	 	 	 	for(c5=c4+1;c5 <= M-2;c5+=1)
				 	 	 	 	 {
									#pragma ivdep
                                                			#pragma vector always
                                                			#pragma simd
				 	 	 	 	 	for(c6=-c4+c5+1;c6 <= -c4+M-1;c6+=1)
				 	 	 	 	 	 {
				 	 	 	 	 	 	S3((c1),(c2),(c3),(c4),(c5),(c6));
				 	 	 	 	 	 }
				 	 	 	 	 }
				 	 	 	 }
				 	 	 	S4((c1),(c2),(c3),(M-2),(M-2),(1));
				 	 	 }
				 	 	for(c4=0;c4 <= M-2;c4+=1)
				 	 	 {
				 	 	 	S1((c1),(c2),(c1+c2),(c4),(c4),(0));
				 	 	 	for(c5=c4+1;c5 <= M-1;c5+=1)
				 	 	 	 {
				 	 	 	 	S2((c1),(c2),(c1+c2),(c4),(c5),(-c4+c5));
				 	 	 	 }
				 	 	 }
				 	 	S1((c1),(c2),(c1+c2),(M-1),(M-1),(0));
				 	 }
				 }
			}
		}
		if ((M == 2)) {
			{
				for(c1=2;c1 <= N-1;c1+=1)
				 {
				 	#pragma omp parallel for private(c3) schedule(dynamic)
				 	for(c2=0;c2 <= -c1+N-1;c2+=1)
				 	 {
				 	 	S5((c1),(c2),(c2),(0),(0),(1));
				 	 	for(c3=c2+1;c3 <= c1+c2-1;c3+=1)
				 	 	 {
				 	 	 	S4((c1),(c2),(c3),(0),(0),(1));
				 	 	 }
				 	 	S1((c1),(c2),(c1+c2),(0),(0),(0));
				 	 	S2((c1),(c2),(c1+c2),(0),(1),(1));
				 	 	S1((c1),(c2),(c1+c2),(1),(1),(0));
				 	 }
				 }
			}
		}
	}
	#undef S0
	#undef S1
	#undef S2
	#undef S3
	#undef S4
	#undef S5
	#undef S6
	
	//Memory Free
}

//Memory Macros
#undef P1
#undef P2
#undef Q


//Common Macro undefs
#undef max
#undef MAX
#undef min
#undef MIN
#undef CEILD
#undef ceild
#undef FLOORD
#undef floord
#undef CDIV
#undef FDIV
#undef LB_SHIFT
#undef MOD
#undef RADD
#undef RMUL
#undef RMAX
#undef RMIN
