// This file is generated from test alphabets program by code generator in alphaz
// To compile this code, use -lm option for math library.

// Includes
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>
#include <string.h>
#include <limits.h>
#include <float.h>


// Common Macros
#define max(x, y)   ((x)>(y) ? (x) : (y))
#define MAX(x, y)	((x)>(y) ? (x) : (y))
#define min(x, y)   ((x)>(y) ? (y) : (x))
#define MIN(x, y)	((x)>(y) ? (y) : (x))
#define CEILD(n,d)  (int)ceil(((double)(n))/((double)(d)))
#define ceild(n,d)  (int)ceil(((double)(n))/((double)(d)))
#define FLOORD(n,d) (int)floor(((double)(n))/((double)(d)))
#define floord(n,d) (int)floor(((double)(n))/((double)(d)))
#define CDIV(x,y)    CEILD((x),(y))
#define div(x,y)    CDIV((x),(y))
#define FDIV(x,y)    FLOORD((x),(y))
#define LB_SHIFT(b,s)  ((int)ceild(b,s) * s)
#define MOD(i,j)   ((i)%(j))
#define mallocCheck(v,s,d) if ((v) == NULL) { printf("Failed to allocate memory for %s : size=%lu\n", "sizeof(d)*(s)", sizeof(d)*(s)); exit(-1); }

// Common functions for min and max
//functions for integer max
inline int __max_int(int x, int y){
	return ((x)>(y) ? (x) : (y));
}

inline short __max_short(short x, short y){
	return ((x)>(y) ? (x) : (y));
}

inline long __max_long(long x, long y){
	return ((x)>(y) ? (x) : (y));
}

inline unsigned int __max_unsigned_int(unsigned int x, unsigned int y){
	return ((x)>(y) ? (x) : (y));
}

inline unsigned short __max_unsigned_short(unsigned short x, unsigned short y){
	return ((x)>(y) ? (x) : (y));
}

//function for float max
inline float __max_float(float x, float y){
	return ((x)>(y) ? (x) : (y));
}

//function for double max
inline double __max_double(double x, double y){
	return ((x)>(y) ? (x) : (y));
}

//function for integer min
inline int __min_int(int x, int y){
	return ((x)>(y) ? (y) : (x));
}

inline short __min_short(short x, short y){
	return ((x)>(y) ? (y) : (x));
}

inline long __min_long(long x, long y){
	return ((x)>(y) ? (y) : (x));
}

inline unsigned int __min_unsigned_int(unsigned int x, unsigned int y){
	return ((x)>(y) ? (y) : (x));
}

inline unsigned short __min_unsigned_short(unsigned short x, unsigned short y){
	return ((x)>(y) ? (y) : (x));
}

inline unsigned long __min_unsigned_long(unsigned long x, unsigned long y){
	return ((x)>(y) ? (y) : (x));
}

inline float __min_float(float x, float y){
	return ((x)>(y) ? (y) : (x));
}

inline double __min_double(double x, double y){
	return ((x)>(y) ? (y) : (x));
}


///Global Variables
static double* P1;
static double* P2;
static double* FTable;
static char* _flag_FTable;


//Local Function Declarations
double reduce_osp_sq_FTable_1(long, long, int, int, int, int);
double eval_FTable(long, long, int, int, int, int);

//Memory Macros
#define P1(i,j) P1[(i) * (N) + j]
#define P2(i,j) P2[(i) * (M) + j]
#define FTable(i1,j1,i2,j2) FTable[(i1) * ((N) * (M) * (M)) + (j1) * ((M) * (M)) + (i2) * (M) + j2]
#define _flag_FTable(i1,j1,i2,j2) _flag_FTable[(i1) * ((N) * (M) * (M)) + (j1) * ((M) * (M)) + (i2) * (M) + j2]

void osp_sq_verify(long N, long M, double* _local_P1, double* _local_P2, double* _local_FTable){
	///Parameter checking
	if (!((N >= 2 && M >= 2))) {
		printf("The value of parameters are not valid.\n");
		exit(-1);
	}
	//Copy to global
	P1 = _local_P1;
	P2 = _local_P2;
	FTable = _local_FTable;
	
	//Memory Allocation
	int mz1, mz2, mz3, mz4;
	
	_flag_FTable = (char*)malloc(sizeof(char)*((N) * (N) * (M) * (M)));
	mallocCheck(_flag_FTable, ((N) * (N) * (M) * (M)), char);
	memset(_flag_FTable, 'N', ((N) * (N) * (M) * (M)));
	#define S0(i1,j1,i2,j2) eval_FTable(N,M,i1,j1,i2,j2)
	{
		//Domain
		//{i1,j1,i2,j2|i1>=0 && N>=i1+1 && j1>=i1 && N>=j1+1 && i2>=0 && M>=i2+1 && j2>=i2 && M>=j2+1 && N>=2 && M>=2}
		int c1,c2,c3,c4;
		for(c1=0;c1 <= N-1;c1+=1)
		 {
		 	for(c2=c1;c2 <= N-1;c2+=1)
		 	 {
		 	 	for(c3=0;c3 <= M-1;c3+=1)
		 	 	 {
		 	 	 	for(c4=c3;c4 <= M-1;c4+=1)
		 	 	 	 {
		 	 	 	 	S0((c1),(c2),(c3),(c4));
		 	 	 	 }
		 	 	 }
		 	 }
		 }
	}
	#undef S0
	
	//Memory Free
	free(_flag_FTable);
}
double reduce_osp_sq_FTable_1(long N, long M, int i1p, int j1p, int i2p, int j2p){
	double reduceVar = 0;
	#define S0(i1,j1,i2,j2,d,e) reduceVar = (reduceVar)+((eval_FTable(N,M,i1,d,i2,e))*(eval_FTable(N,M,d+1,j1,e+1,j2)))
	{
		//Domain
		//{i1,j1,i2,j2,d,e|i1p>=0 && j1p>=i1p+1 && i2p>=0 && j2p>=i2p+1 && M>=j2p+1 && N>=j1p+1 && M>=2 && N>=2 && d>=i1 && j1>=d+1 && e>=i2 && j2>=e+1 && j1>=i1+1 && j2>=i2+1 && i1>=0 && N>=i1+1 && e>=-1 && N>=d+2 && i2>=0 && M>=i2+1 && N>=j1+1 && M>=e+2 && M>=j2+1 && d>=-1 && i1p==i1 && j1p==j1 && i2p==i2 && j2p==j2}
		int c5,c6;
		for(c5=i1p;c5 <= j1p-1;c5+=1)
		 {
		 	for(c6=i2p;c6 <= j2p-1;c6+=1)
		 	 {
		 	 	S0((i1p),(j1p),(i2p),(j2p),(c5),(c6));
		 	 }
		 }
	}
	#undef S0
	return reduceVar;
}
double eval_FTable(long N, long M, int i1, int j1, int i2, int j2){
	if ( _flag_FTable(i1,j1,i2,j2) == 'N' ) {
		_flag_FTable(i1,j1,i2,j2) = 'I';
	//Body for FTable
		FTable(i1,j1,i2,j2) = (((j1 == i1))?P2(i2,j2):(((j2 == i2 && j1 >= i1+1))?P1(i1,j1):(reduce_osp_sq_FTable_1(N,M,i1,j1,i2,j2))));
		_flag_FTable(i1,j1,i2,j2) = 'F';
	} else if ( _flag_FTable(i1,j1,i2,j2) == 'I' ) {
		printf("There is a self dependence on FTable at (%d,%d,%d,%d) \n",i1,j1,i2,j2);
		exit(-1);
	}
	return FTable(i1,j1,i2,j2);
}

//Memory Macros
#undef P1
#undef P2
#undef FTable
#undef _flag_FTable


//Common Macro undefs
#undef max
#undef MAX
#undef min
#undef MIN
#undef CEILD
#undef ceild
#undef FLOORD
#undef floord
#undef CDIV
#undef FDIV
#undef LB_SHIFT
#undef MOD
